#include <stdbool.h>
#include "..\SMSlib\SMSlib.h"

#include "data.h"

unsigned int splitline=90;
unsigned char BWpalette[16];
unsigned char toBW[10]={0x00,0x00, 0x15,0x15,0x15, 0x2A,0x2A,0x2A, 0x3F,0x3F};

void lineHandler (void) {
  SMS_disableLineInterrupt();
  SMS_loadBGPalette(BWpalette);
}

void prepareBWpalette (unsigned char *palette) {
  unsigned char i;
  for (i=0;i<16;i++) {
    BWpalette[i]=toBW[((*palette & 0x03)+((*palette>>2) & 0x03)+((*palette>>4) & 0x03))];
    palette++;
  }
}

void main() {
  unsigned int k;

  /* load tiles and tilemap data */
  SMS_loadTiles(image448_tiles_bin, 0, image448_tiles_bin_len/32);
  SMS_loadTileMap (0,0,(unsigned int *)image448_tilemap_bin,image448_tilemap_bin_len/2);

  /* prepare B/W palette from image original palette */
  prepareBWpalette(image448_palette_bin);
  
  /* remove sprites from screen (by defining 0 sprites)*/
  SMS_initSprites();
  SMS_finalizeSprites();
  SMS_copySpritestoSAT();

  /* set the line interrupt handler */
  SMS_setLineInterruptHandler(lineHandler);
  
  /* leave some room above image (wraps at 224 so let's set 224-8) */
  SMS_setBGScrollY(224-8);

  /* we're ready, turn on the screen! */
  SMS_displayOn();

  while (true) {
    SMS_waitForVBlank();
    SMS_enableLineInterrupt();
    SMS_setLineCounter(splitline);
    SMS_loadBGPalette(image448_palette_bin);
    k=SMS_getKeysHeld();
    if ((k & PORT_A_KEY_UP) && (splitline>4))
      splitline--;
    else if ((k & PORT_A_KEY_DOWN) && (splitline<170))
      splitline++;

    if (SMS_queryPauseRequested()) {
      splitline=90;
      SMS_resetPauseRequest();
    }
  }
}
